function Latzko
%Latzko equation, problem 24 in list of test problems in book of Pryce
addpath(genpath(pwd))
addpath(genpath('./source'))
a=0;
b=1; %infinite integration interval

tol=1e-10; %user input tolerance


print_messages(true);

problem.pfun=@pfun; %function handles of p,q,w functions
problem.qfun=@qfun;
problem.wfun=@wfun;
problem.a=a;        %integration interval
problem.b=b;
problem.bcs=[1 0];  %let the program pick the boundary conditions for the singular endpoint
problem.partition=[];

%compute first 11 eigenvalues
[E,partition]=calculate_eigenvalues(problem,0,10,tol,true);
disp('  k           E_k           estimated error ')
for n=1:length(E.indices)
  disp(sprintf('%3d     %18.12f       %5.1E    ',E.indices(n),E.eigenvalues(n),E.errors(n)));
end


number_of_meshpoints=length(partition.bp.xs)


function res=pfun(x)
res=1-x.^7;

function res=qfun(x)
res=0;

function res=wfun(x)
res=x.^7;
