function Legendre
%LCN endpoints
addpath(genpath(pwd))
addpath(genpath('./source'))
a=-1;
b=1; %infinite integration interval

tol=1e-7; %user input tolerance

%"exact" eigenvalues
exact=(0:100).*(1:101);

print_messages(true);

problem.pfun=@pfun; %function handles of p,q,w functions
problem.qfun=@qfun;
problem.wfun=@wfun;
problem.a=a;        %integration interval
problem.b=b;
problem.bcs=[];  %let the program pick the boundary conditions for this problem with singular endpoints
problem.partition=[];

%compute first 11 eigenvalues
[E,partition]=calculate_eigenvalues(problem,0,10,tol,true);
disp('  k           E_k              exact error    estimated error   relative error')
for n=1:length(E.indices)
  disp(sprintf('%3d     %18.12f       %5.1E       %5.1E         %5.1E',E.indices(n),E.eigenvalues(n),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1)),abs(E.errors(n)),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1))/max(exact(E.indices(n)+1),1)));
end


number_of_meshpoints=length(partition.bp.xs)


function res=pfun(x)
res=1-x.^2;

function res=qfun(x)
res=0;

function res=wfun(x)
res=1;
