function Wicke_Harris
%Reference; Wicke and Harris, J. Chem. Phys 64 (1976)
addpath(genpath(pwd))
addpath(genpath('./source'))
a=0;
b=inf; %infinite integration interval

tol=1e-6; %user input tolerance

print_messages(true);

problem.pfun=@pfun; %function handles of p,q,w functions
problem.qfun=@qfun;
problem.wfun=@wfun;
problem.a=a;        %integration interval
problem.b=inf;
problem.bcs=[1 0 1 0];  %boundary conditions
problem.partition=[];

%compute eigenvalues
[E,partition]=calculate_eigenvalues(problem,0,61,tol,true);
disp('  k           E_k              estimated error   relative error')
for n=1:length(E.indices)
  disp(sprintf('%3d     %18.12f       %5.1E         %5.1E',E.indices(n),E.eigenvalues(n),...
      abs(E.errors(n)),abs(E.errors(n)/E.eigenvalues(n))));
end


%coefficient functions
function res=pfun(x)
res=1;

function res=qfun(x)
res=1250*exp(-83.363*(x-2.47826).^2)+3906.25*(1-exp(2.3237-x)).^2;

function res=wfun(x)
res=1;
