function regular_slp
%a regular problem in the general SL-form
addpath(genpath(pwd))
addpath(genpath('./source'))

exact=64/9*(1:21).^2*pi^2;   %exact eigenvalues 

tol=1e-9; %user input tolerance

print_messages(true);

problem.pfun=@pfun; %function handles to p,q,w functions
problem.qfun=@qfun;
problem.wfun=@wfun;
problem.a=1;        %integration interval
problem.b=2;
problem.bcs=[1 0 1 0]; %boundary conditions
problem.partition=[];

%compute first eigenvalues
[E,partition]=calculate_eigenvalues(problem,0,20,tol,true);
disp('  k           E_k              exact error    estimated error   relative error')
for n=1:length(E.indices)
  disp(sprintf('%3d     %18.12f       %5.1E       %5.1E         %5.1E',E.indices(n),E.eigenvalues(n),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1)),abs(E.errors(n)),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1))/exact(E.indices(n)+1)));
end



% 
function res=pfun(x)
res=1;

function res=qfun(x)
res=3./4./x.^2;         %must be vectorized

function res=wfun(x)
res=1./x.^6;




