function simple_slp
a=1;
b=exp(1);

tol=1e-8;
exact=(((0:20)+1)*pi).^2+1/4;
print_messages(true);

problem.pfun=@pfun; %function handles to p,q,w functions
problem.qfun=@qfun;
problem.wfun=@wfun;
problem.a=a;   %integration interval
problem.b=b;
problem.bcs=[1 0 1 0]; %boundary conditions
problem.partition=[];

%compute first 20 eigenvalues
[E,partition]=calculate_eigenvalues(problem,0,19,tol,true);
disp('  k           E_k              exact error    estimated error   relative error')
for n=1:length(E.indices)
  disp(sprintf('%3d     %18.12f       %5.1E       %5.1E         %5.1E',E.indices(n),E.eigenvalues(n),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1)),abs(E.errors(n)),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1))/exact(E.indices(n)+1)));
end


%coefficient functions
function res=pfun(x)
res=1;

function res=qfun(x)
res=0;

function res=wfun(x)
res=1./x.^2;


