function simple_slp3
%paper Kosowski
addpath(genpath(pwd))
addpath(genpath('./source'))
a=1;
b=exp(pi);

%exact eigenvalues
exact=(1:11).^2+0.25;


tol=1e-8;
print_messages(true);

problem.pfun=@pfun; %function handles of p,q, w functions
problem.qfun=@qfun;
problem.wfun=@wfun;
problem.a=a;       %integration interval
problem.b=b;
problem.bcs=[1 0 1 0];  %boundary conditions
problem.partition=[];
[E,partition]=calculate_eigenvalues(problem,0,9,tol,true);
disp('  k           E_k              exact error    estimated error')
for n=1:length(E.indices)
  disp(sprintf('%3d     %18.12f       %5.1E     %5.1E',E.indices(n),E.eigenvalues(n),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1)),abs(E.errors(n))));
end  

%coefficient functions
function res=pfun(x)
res=x.^2;

function res=qfun(x)
res=0;

function res=wfun(x)
res=1;


