function [numberOfZeros,phi]=locate_eigenvalue(varargin)
% LOCATE_EIGENVALUE
% [numberOfZeros]=locate_eigenvalue(eold,part)
%   
% For given e (eold) the Schrodinger equation is integrated from the
% a to b  to produce the Prufer's theta(eold)/pi (pruf).    
eold=varargin{1}; part=varargin{2}; 

%boundary condition in a:
if part.inda>0
   if eold*part.w0(1)-part.q0(1)<0
         yi=[0;1];
   elseif part.p0(1)> (eold*part.w0(1)-part.q0(1))
        yi=[-1;0];
   else
        yi=[0;1];
   end
else
   ma=max(abs(part.bcs(1)),abs(part.bcs(2)));
   yi=[-part.bcs(2)/ma;part.bcs(1)/ma]; 
end
%matching point;
%better from the two ends to the middle!
ma=max(part.inda+1,part.inf_a+1);
mi=length(part.w0)-max(part.indb,part.inf_b);
[m,imatch]=max((eold*part.w0(ma:mi)-part.q0(ma:mi)).*part.p0(ma:mi));
imatch=imatch+ma-1;
% shoot from a to matching point
[yl,thetaL] = propagate_solution(part,eold,yi,imatch,true);
% boundary condition in b:
if part.indb>0
    if eold*part.w0(end)-part.q0(end)<0
         yi=[0;1];
    elseif (part.p0(end))> (eold*part.w0(end)-part.q0(end)) 
        yi=[-1;0];
    else
        yi=[0;1];
    end
else
  ma=max(abs(part.bcs(3)),abs(part.bcs(4)));
  yi=[-part.bcs(4)/ma;part.bcs(3)/ma];
end
%shoot from b to matching point
[yr,thetaR] = propagate_solution(part,eold,yi,imatch,false);
numberOfZeros = (thetaL-thetaR)/pi;
if nargin<3
 numberOfZeros=ceil(numberOfZeros);
end
phi=yl(1)*yr(2)-yl(2)*yr(1);





