function Klotter
%Reference, Klotter, Technische Schwingungslehre, I
addpath(genpath(pwd))
addpath(genpath('./source'))

a=8/7;
b=8;

exact=((0:120)+1).^2; %exact eigenvalues
tol=1e-11;  %user input tolerance

print_messages(true);

problem.pfun=@pfun;  %function handles to p,q,w functions
problem.qfun=@qfun;
problem.wfun=@wfun;
problem.a=a;         %integration interval
problem.b=b;
problem.bcs=[1 0 1 0];
problem.partition=[];

%comute first 11 eigenvalues
[E,partition]=calculate_eigenvalues(problem,0,10,tol,true);
disp('  k           E_k              exact error    estimated error')
for n=1:length(E.indices)
  disp(sprintf('%3d     %18.12f       %5.1E     %5.1E',E.indices(n),E.eigenvalues(n),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1)),abs(E.errors(n))));
end
number_intervals=length(partition.bp.p0)


%compute some higher eigenvalues
problem.partition=partition; %partition can be reused, does not have to be recomputed
[E,partition]=calculate_eigenvalues(problem,100,110,tol,true);
disp('  k           E_k              exact error    estimated error')
for n=1:length(E.indices)
  disp(sprintf('%3d     %18.12f       %5.1E     %5.1E',E.indices(n),E.eigenvalues(n),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1)),abs(E.errors(n))));
end


%coefficient functions
function res=pfun(x)
res=1;

function res=qfun(x)
res=3./(4*x.^2);

function res=wfun(x)
res=64*pi^2./(9*x.^6);
