function Laguerre
%Laguerre's equation
addpath(genpath(pwd))
addpath(genpath('./source'))
a=0;
b=inf; %infinite integration interval

tol=1e-8; %user input tolerance

%"exact" eigenvalues
exact=4*((0:100)+1);

print_messages(true);

problem.pfun=@pfun; %function handles of p,q,w functions
problem.qfun=@qfun;
problem.wfun=@wfun;
problem.a=a;        %integration interval
problem.b=b;
problem.bcs=[1 0 1 0];  %boundary conditions
problem.partition=[];

%compute first 26 eigenvalues
[E,partition]=calculate_eigenvalues(problem,0,25,tol,true);
disp('  k           E_k              exact error    estimated error')
for n=1:length(E.indices)
  disp(sprintf('%3d     %18.12f       %5.1E     %5.1E',E.indices(n),E.eigenvalues(n),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1)),abs(E.errors(n))));
end

number_of_meshpoints=length(partition.bp.xs)


%coefficient functions
function res=pfun(x)
res=1;

function res=qfun(x)
res=x.^2+3./(4*x.^2);

function res=wfun(x)
res=1;
