function simple_slp2
addpath(genpath(pwd))
addpath(genpath('./source'))
a=0;
b=pi;

%"exact" eigenvalues
exact=1e2*[-0.00802320340298, ...
   0.01425152851206, ...
   0.03698924850818, ...
   0.06528415045142, ...
   0.10134768231545, ...
   0.14549052553274, ...
   0.19772327828672, ...
   0.25803174438647, ...
   0.32640544211774, ...
   0.40283816640345, ...
   0.48732626357709, ...
   0.57986750667973, ...
   0.68046048431783, ...
   0.78910426927596, ...
   0.90579823286790, ...
   1.03054193691221, ...
   1.16333506855740, ...
   1.30417739965568, ...
   1.45306876068698, ...
   1.61000902357809, ...
   1.77499809011668];



tol=1e-8;
print_messages(true);

problem.pfun=@pfun; %function handles to p,q,w functions
problem.qfun=@qfun;
problem.wfun=@wfun;
problem.a=a;        %integration interval
problem.b=b;
problem.bcs=[1 0 1 0];

problem.partition=[];
%compute first 11 eigenvalues
[E,partition]=calculate_eigenvalues(problem,0,10,tol,true);
disp('  k           E_k              exact error    estimated error   relative error')
for n=1:length(E.indices)
  disp(sprintf('%3d     %18.12f       %5.1E       %5.1E         %5.1E',E.indices(n),E.eigenvalues(n),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1)),abs(E.errors(n)),...
      abs(E.eigenvalues(n)-exact(E.indices(n)+1))/exact(E.indices(n)+1)));
end   

%coefficient functions
function res=pfun(x)
res=1./(x+1);

function res=qfun(x)
res=2*cos(2*x);

function res=wfun(x)
res=1;


