function [partition]=calculate_partition_init(problem,pmin,pmax,tol,indices)
%automatic stepsize selection

pfun=problem.pfun; qfun=problem.qfun; wfun = problem.wfun;
a=problem.a; b=problem.b;
N=10;
inda=0; indb=0;

try
tst=qfun([(a+b)/2 (a+b)/2]);
tst=wfun([(a+b)/2 (a+b)/2]);
tst=pfun([(a+b)/2 (a+b)/2]);
catch 
    error('There is a problem with the evaluation of the q, w or p function. Make sure the q, w, and p functions are vectorized ( insert a . before any ^, * or /)')
end

tol=tol/2;

warning off
qf=qfun(a);
singa=false; singb=false;
epsb=b; epsa=a;
if ~isinf(a) && (isinf(qf) || isnan(qf) || isinf(wfun(a)) || isinf(1/pfun(a))|| isnan(qf))
    %singular endpoint a
    singa=true;
    epsa=get_epsa(a,b,pmin,indices);
    if epsa==a;
        singa=false;
    end
    problem.epsa=epsa;
end
if ~isinf(b) && (isinf(qfun(b)) || isinf(wfun(b)) || isinf(1/pfun(b)) || isnan(qfun(b)))
    %singular endpoint b
    singb=true;   
    epsb=get_epsb(a,b,pmin,indices);
    if epsb==b
        singb=false;
    end
end
problem.epsa=epsa;  problem.epsb=epsb;
infa=false;infb=false;
if isinf(a)
    %infinite endpoint a
    infa=true;
    epsa = get_x_min(problem, pmax,indices);
    N=1;
end
if isinf(b)
    %infinite endpoint b
    epsb = get_x_max(problem, pmax,indices);
    infb=true;
    N=1;
end

warning on;

%uniform mesh
% nsteps=44;
% h = (epsb-epsa)/nsteps; 
% x=epsa;
% xs(1)=epsa;
% for i=1:nsteps
%  [qq0,qq1,qq2]=get_LegendrePolyn(qfun,x,h); 
%  [ww0,ww1,ww2]=get_LegendrePolyn(wfun,x,h); 
%  [pp0,pp1,pp2]=get_LegendrePolyn2(pfun,x,h); 
%  x=x+h;
%  xs(i+1)=x;
%  q0(i)=qq0;q1(i)=qq1;q2(i)=qq2;
%  w0(i)=ww0;w1(i)=ww1;w2(i)=ww2;
%  p0(i)=pp0;p1(i)=pp1;p2(i)=pp2;
% end


%automatic stepsize selection over [epsa,epsb]

trial_h = (epsb-epsa)/50; 
if singa
   trial_h=min((epsa-a)*10,trial_h);
end
prev_h = 0;
i=0;
x=epsa;
xs(1)=epsa;


if get_error((epsb-epsa)/20,epsa) < 1e-12 && get_error((epsb-epsa)/2,(epsa+epsb)/2) < 1e-12
 %the polynomial approximation of the coefficient functions is exact  
 nsteps=50;
 if indices && pmin >50
     nsteps=100;
 end
 h = (epsb-epsa)/nsteps; 
 x=epsa;
 xs(1)=epsa;
 for i=1:nsteps
   [qq0,qq1,qq2]=get_LegendrePolyn(qfun,x,h); 
   [ww0,ww1,ww2]=get_LegendrePolyn(wfun,x,h); 
   [pp0,pp1,pp2]=get_LegendrePolyn2(pfun,x,h); 
   x=x+h;
   xs(i+1)=x;
   q0(i)=qq0;q1(i)=qq1;q2(i)=qq2;
   w0(i)=ww0;w1(i)=ww1;w2(i)=ww2;
   p0(i)=pp0;p1(i)=pp1;p2(i)=pp2;
  end
 
%   while epsb-x>eps
%    i=i+1;   
%    it = 0;
%    delta = 1;
%    h = trial_h;
%    while delta > 0.01 && it < 20
%      it = it +1;
%      h = min([h,epsb-x,(epsb-epsa)/N]);  
%      if h==epsb-x && prev_h==epsb-x
%         break;
%      end
%      e_loc = min(h,1)^2*get_error2(h,x);
%      prev_h = h;
%      hnew = 10*h;
%      if(e_loc > eps) 
%         hnew = h * (tol / e_loc)^(1/7);
%      end
%      quo = hnew/h;
%      h = hnew;
%      delta = abs(quo - 1);
%    end
%    h = min(prev_h,h);
%    [qq0,qq1,qq2]=get_LegendrePolyn(qfun,x,h); 
%    [ww0,ww1,ww2]=get_LegendrePolyn(wfun,x,h); 
%    [pp0,pp1,pp2]=get_LegendrePolyn2(pfun,x,h); 
%    x=x+h; xs(i+1)=x; trial_h=h; 
%    q0(i)=qq0;q1(i)=qq1;q2(i)=qq2; 
%    w0(i)=ww0;w1(i)=ww1;w2(i)=ww2;
%    p0(i)=pp0;p1(i)=pp1;p2(i)=pp2;
%   end
else
  %equidistribution of local error  
  while epsb-x>eps
   i=i+1;   
   it = 0;
   delta = 1;
   h = trial_h;
   while delta > 0.01 && it < 20
     it = it +1;
     h = min([h,epsb-x,(epsb-epsa)/N]);  
     if h==epsb-x && prev_h==epsb-x
        break;
     end
     [e_loc,qq0,qq1,qq2,ww0,ww1,ww2,pp0,pp1,pp2] = get_error(h,x); %get_error geeft in feite V3/h^2
     e_loc=h^2*e_loc;
     prev_h = h;
     hnew = 10*h;
     if(e_loc > eps) 
        hnew = h * (tol / e_loc)^(1/6);
     end
     quo = hnew/h;
     h = hnew;
     delta = abs(quo - 1);
   end
   h=prev_h;
   x=x+h;
   xs(i+1)=x;
   trial_h=h; 
   q0(i)=qq0;q1(i)=qq1;q2(i)=qq2; %store data related to this mesh for later use
   w0(i)=ww0;w1(i)=ww1;w2(i)=ww2;
   p0(i)=pp0;p1(i)=pp1;p2(i)=pp2;
  end
end
if h<max(1e-12,(xs(end-1)-xs(end-2))/6)  %avoid mini last step
    xs(i)=xs(i+1);
    xs(i+1)=[];
    q0(i)=[];q1(i)=[];q2(i)=[];
    w0(i)=[];w1(i)=[];w2(i)=[];
    p0(i)=[];p1(i)=[];p2(i)=[];
    [qq0(i-1),qq1(i-1),qq2(i-1)]=get_LegendrePolyn(qfun,xs(i-1),xs(i)-xs(i-1)); 
    [ww0(i-1),ww1(i-1),ww2(i-1)]=get_LegendrePolyn(wfun,xs(i-1),xs(i)-xs(i-1)); 
    [pp0(i-1),pp1(i-1),pp2(i-1)]=get_LegendrePolyn2(pfun,xs(i-1),xs(i)-xs(i-1)); 
end


if singa % a is singular
    %include some extra meshpoints near singularity
     F=xs(2)-xs(1);
     N=max(ceil((epsa-a)/F)*2,4);
     h=(epsa-a)/N;
     x=a; xsa=a;
     for i=1:N
        [q0t(i),q1t(i),q2t(i)]=get_LegendrePolyn(qfun,x,h);
        [w0t(i),w1t(i),w2t(i)]=get_LegendrePolyn(wfun,x,h);
        [p0t(i),p1t(i),p2t(i)]=get_LegendrePolyn2(pfun,x,h);
        x=x+h; 
        xsa=[xsa x];
     end
     xs=[xsa(1:end-1) xs];
     q0=[q0t q0(1:end)];q1=[q1t q1(1:end)];q2=[q2t q2(1:end)];
     w0=[w0t w0(1:end)];w1=[w1t w1(1:end)];w2=[w2t w2(1:end)];
     p0=[p0t p0(1:end)];p1=[p1t p1(1:end)];p2=[p2t p2(1:end)];
     inda=inda+N;
end
if singb % b is singular
     F=xs(end)-xs(end-1); 
     Nb=max(ceil((b-epsb)/F)*2,4);
     h=(b-epsb)/Nb;
     x=epsb;      xsb=b;
     for i=1:Nb
        [q0t(i),q1t(i),q2t(i)]=get_LegendrePolyn(qfun,x,h);
        [w0t(i),w1t(i),w2t(i)]=get_LegendrePolyn(wfun,x,h);
        [p0t(i),p1t(i),p2t(i)]=get_LegendrePolyn2(pfun,x,h);
        x=x+h;
        xsb=[xsb x];
     end
     if abs(xsb(end)-b) < eps
         xsb(end)=b;
     end     
     xs=[xs xsb(2:end)];
     q0=[q0(1:end) q0t];q1=[q1(1:end) q1t];q2=[q2(1:end) q2t];
     w0=[w0(1:end) w0t];w1=[w1(1:end) w1t];w2=[w2(1:end) w2t];
     p0=[p0(1:end) p0t];p1=[p1(1:end) p1t];p2=[p2(1:end) p2t];
     indb=indb+Nb;
end

% 
part.inf_a=false; part.inf_b=false;
if infa % a is infinite
    %transformation t=-1/x over first step [-inf,epsa]
    xi=1/realmax;  xf=-1/epsa;
    [qq0,qq1,qq2]=get_LegendrePolyn(@qfunt,xi,xf-xi); 
    [ww0,ww1,ww2]=get_LegendrePolyn(@wfunt,xi,xf-xi); 
    [pp0,pp1,pp2]=get_LegendrePolyn2(@pfunt,xi,xf-xi);
    xs=[-inf xs];
    p0=[pp0 p0]; q0=[qq0 q0]; w0=[ww0 w0];
    p1=[pp1 p1]; q1=[qq1 q1]; w1=[ww1 w1];
    p2=[pp2 p2]; q2=[qq2 q2]; w2=[ww2 w2];
    part.inf_a=true;
end
if infb %b is infinite
    %transformation t=-1/x over last step [epsb, inf]
    xi=-1/epsb;  xf=-1/realmax;
    [qq0,qq1,qq2]=get_LegendrePolyn(@qfunt,xi,xf-xi); 
    [ww0,ww1,ww2]=get_LegendrePolyn(@wfunt,xi,xf-xi); 
    [pp0,pp1,pp2]=get_LegendrePolyn2(@pfunt,xi,xf-xi);
    xs=[xs inf];
    p0=[p0 pp0]; q0=[q0 qq0]; w0=[w0 ww0];
    p1=[p1 pp1]; q1=[q1 qq1]; w1=[w1 ww1];
    p2=[p2 pp2]; q2=[q2 qq2]; w2=[w2 ww2];
    part.inf_b=true;
end
part.xs=xs; part.p0=p0; part.q0=q0;
part.w0=w0; part.p1=p1; part.q1=q1;
part.w1=w1; part.p2=p2; part.q2=q2;
part.w2=w2; part.inda=inda; part.indb=indb;


% reference partition:
if part.inf_a
    ii=2;
    xs=part.xs(2);
else
    ii=1;
    xs=part.xs(1);
end
if part.inf_b
    ie=length(part.xs)-2;
else
    ie=length(part.xs)-1;
end
x=xs;
k=1;
q0=zeros(1,2*(ie-ii+1)); q1=zeros(1,2*(ie-ii+1)); q2=zeros(1,2*(ie-ii+1));
w0=zeros(1,2*(ie-ii+1)); w1=zeros(1,2*(ie-ii+1)); w2=zeros(1,2*(ie-ii+1));
p0=zeros(1,2*(ie-ii+1)); p1=zeros(1,2*(ie-ii+1)); p2=zeros(1,2*(ie-ii+1));
for i=ii:ie
   h=(part.xs(i+1)-part.xs(i))/2; 
   [q0(k),q1(k),q2(k)]=get_LegendrePolyn(qfun,x,h);
   [w0(k),w1(k),w2(k)]=get_LegendrePolyn(wfun,x,h);
   [p0(k),p1(k),p2(k)]=get_LegendrePolyn2(pfun,x,h);
   x=x+h; xs=[xs x];
   k=k+1;
   %
   [q0(k),q1(k),q2(k)]=get_LegendrePolyn(qfun,x,h);
   [w0(k),w1(k),w2(k)]=get_LegendrePolyn(wfun,x,h);
   [p0(k),p1(k),p2(k)]=get_LegendrePolyn2(pfun,x,h);
   x=x+h; xs=[xs x]; k = k+1;
end
if infa %a infinite
   p0=[part.p0(1) p0]; q0=[part.q0(1) q0]; w0=[part.w0(1) w0];
   p1=[part.p1(1) p1]; q1=[part.q1(1) q1]; w1=[part.w1(1) w1];
   p2=[part.p2(1) p2]; q2=[part.q2(1) q2]; w2=[part.w2(1) w2];
   xs=[-inf xs];
end
rp.inf_a=infa;
rp.inf_b=infb;
if infb 
    %infinite endpoint b   
   p0=[p0 part.p0(end)]; q0=[q0 part.q0(end)]; w0=[w0 part.w0(end)];
   p1=[p1 part.p1(end)]; q1=[q1 part.q1(end)]; w1=[w1 part.w1(end)];
   p2=[p2 part.p2(end)]; q2=[q2 part.q2(end)]; w2=[w2 part.w2(end)];
   xs=[xs inf];
end
rp.xs=xs;
rp.p0=p0; rp.q0=q0; rp.w0=w0;
rp.p1=p1; rp.q1=q1; rp.w1=w1;
rp.p2=p2; rp.q2=q2; rp.w2=w2;
rp.inda=part.inda*2;
rp.indb=part.indb*2;

partition.bp=part;
partition.rp=rp;
partition.qfun=qfun;
partition.wfun=wfun;
partition.pfun=pfun;
%partition.a=a;

%coefficient functions after t=-1/x transformation near infinity:
function pf=pfunt(xt)
      pf=pfun(-1./xt).*xt.^2;  
 end
function qf=qfunt(xt)
      qf=qfun(-1./xt)./xt.^2;
end
function wf=wfunt(xt)
      wf=wfun(-1./xt)./xt.^2;
end

 function [e_loc,qq0,qq1,qq2,ww0,ww1,ww2,pp0,pp1,pp2] = get_error(h,x)
[qq0,qq1,qq2]=get_LegendrePolyn(qfun,x,h);
[ww0,ww1,ww2]=get_LegendrePolyn(wfun,x,h);
[pp0,pp1,pp2]=get_LegendrePolyn2(pfun,x,h);
qf=qfun(x+h); wf=wfun(x+h); pf=pfun(x+h);
h2=h^2;
qe=abs(qf-(qq0+qq1/h2+qq2/h2));%/max(1,abs(qf)); 
we=abs(wf-(ww0+ww1/h2+ww2/h2));%/max(1,abs(wf));
pe=abs(1/pf-(pp0+pp1/h2+pp2/h2));%/max(1,abs(1/pf));
e_loc=max([qe we pe]);
end

function e_loc = get_error2(h,x)
cc=sqrt(15)/5;
c=h/2*[-cc+1 1 cc+1];
f=qfun(x+c);
f=f.*ones(1,3); %to avoid problems when e.g. fun=1 
qq0=1/10*(4*f(2)+3*f(1)+3*f(3));
qq1=(3*(-1/18*15^(1/2)*(f(1)-f(3))))*h^2;
qq2=5/9*(-2*f(2)+f(1)+f(3))*h^2;
qf=qfun(x+h); 
h2=h^2;
e_loc=abs(qf-(qq0+qq1/h2+qq2/h2)); 
f=wfun(x+c);
f=f.*ones(1,3); 
ww0=1/10*(4*f(2)+3*f(1)+3*f(3));
ww1=(3*(-1/18*15^(1/2)*(f(1)-f(3))))*h^2;
ww2=5/9*(-2*f(2)+f(1)+f(3))*h^2;
wf=wfun(x+h); 
e_loc=max([e_loc abs(wf-(ww0+ww1/h2+ww2/h2))])/1e2;
end

function epsa=get_epsa(a,b,pmin,indices)
lim=1e6;    
if indices
   lim=lim*min(max(pmin,1),100); 
end
if isinf(b)
    b=max(a,0)+1e5;
end
e=min(0.1,(b-a)/1e3);
ref= max( abs([qfun((a+b)/2),1/pfun((a+b)/2),wfun((a+b)/2)]));
tst=max(abs([qfun(a+e),1/pfun(a+e),wfun(a+e)]));
while tst<(lim-ref) 
    e=e/5;
    tst=max(abs([qfun(a+e),1/pfun(a+e),wfun(a+e)]));
end
epsa=a+e;  %heuristiek gebruiken om betere waarde te vinden
end


function epsb=get_epsb(a,b,pmin,indices)
lim=1e6;    
if indices
   lim=lim*min(max(pmin,1),100); 
end    
if isinf(a)
    a=max(b,0)-1e5;
end
e=min(0.1,(b-a)/1e3);
ref= max( abs([qfun((a+b)/2),1/pfun((a+b)/2),wfun((a+b)/2)]));
tst=max(abs([qfun(b-e),1/pfun(b-e),wfun(b-e)]));
while tst<(lim-ref) 
    e=e/5;
    tst=max(abs([qfun(b-e),1/pfun(b-e),wfun(b-e)]));
end
epsb=b-e;  %heuristiek gebruiken om betere waarde te vinden
end


end



function [V0,V1,V2]=get_LegendrePolyn(fun,x,h)
%Gauss Legendre (3 Legendre points)
%realizes approximation by a series over shifted Legendre polynomials
% the F_s coefficients are returned
cc=sqrt(15)/5;
c=h/2*[-cc+1 1 cc+1];
f=fun(x+c);
f=f.*ones(1,3); %to avoid problems when e.g. fun=1 
V0=1/18*(8*f(2)+5*f(1)+5*f(3));
V1=(3*(-1/18*15^(1/2)*(f(1)-f(3))))*h^2;
V2=5/9*(-2*f(2)+f(1)+f(3))*h^2;
end

function [V0,V1,V2]=get_LegendrePolyn2(fun,x,h)
cc=sqrt(15)/5;
c=h/2*[-cc+1 1 cc+1];
f=1./fun(x+c);
f=f.*ones(1,3); %to avoid problems when e.g. fun=1 
V0=1/18*(8*f(2)+5*f(1)+5*f(3));
V1=(3*(-1/18*15^(1/2)*(f(1)-f(3))))*h^2;
V2=5/9*(-2*f(2)+f(1)+f(3))*h^2;
end



function [x] = get_x_max(problem,pmax,indices)
% determines a value for the righthand-truncation point
%lambda_k is approximately the root of int(sqrt(lambda*w-q)/p)=(k+1)*pi where
%the integral is taken over the parts of the interval where (lambda*w-q)/p >0
qfun=problem.qfun; wfun=problem.wfun; pfun=problem.pfun;
if isinf(problem.a)
      hs=0.005*1.01.^(1:6000);
      t=cumsum(hs);
      x1= [-t(end:-1:1) t];
else
      a=problem.a; x1=[];
      if a<0
          he=abs(a)/1000;
          x1=a:he:0;
          a=0;
      end
      hs=0.005*1.01.^(1:6000);
      x1= [x1 cumsum([a hs])];
end
xs= (x1(2:end)+x1(1:end-1))/2;
hs= x1(2:end)-x1(1:end-1);
q=qfun(xs); w=wfun(xs); p=pfun(xs);
if indices
    emin = min(q)/max(w)-1;
    mw=mean(w);
    if mw< eps
      e2 = mean(q)/median(w);  
    else
      e2 = mean(q)/mean(w);
    end
    e=emin;
    he=(e2-emin)/10;
    while true
      tmp0=(e*w-q)./p;
      fi=find(tmp0>0);
      tmp=sum(sqrt(tmp0(fi)).*hs(fi));
      k=tmp/pi-1;
      if k<pmax
          emin=e;
          kmin=k;
          e=e+he;
      else
          emax=e;
          kmax=k;
          break;
      end
    end
    it=0;
    while true
      it=it+1;
      tmp0=(e*w-q)./p;
      fi=find(tmp0>0);
      tmp=sum(sqrt(tmp0(fi)).*hs(fi));
      k=tmp/pi-1;
      if k<pmax-0.2
          emin=e;
          kmin=k;
      elseif k>pmax+2
          emax=e;
          kmax=k;
      else
          break
      end
      if mod(it,2)==0
        e=(emax+emin)/2;
      else
         e=(emax-emin) * (pmax-kmin) / (kmax-kmin) + emin;
         if e==emin
             e=emin+(emax-emin)/10;
         end
      end
      if it>10000
          error(['The eigenvalue with index '  num2str(pmax) ' can not be computed'])
      end
    end
%   turning_point=xs(fi(end)+1)
    ind=fi(end)+1;
    if fi(end)==length(tmp0)
        error(['The eigenvalue with index '  num2str(pmax) ' can not be computed'])
    end
    tmp=0;
    while tmp<18
       tmp=tmp+sqrt(-tmp0(ind))*hs(ind);
       ind=ind+1;
    end
    x=xs(ind);
else
    e=pmax;
    tmp0=(e*w-q)./p;
    fi=find(tmp0>0);
    he=1e-10;
    ind=fi(end)+1;
    tmp=0;
    while tmp<18 && ind<length(tmp0)+1
       tmp=tmp+sqrt(-tmp0(ind))*hs(ind);
       ind=ind+1;
    end
    if ind==length(tmp0)+1
        tmp=sum(sqrt(tmp0(fi)).*hs(fi));
        k=floor(tmp/pi-1);
        kn=k;
        while kn==k
         e=e-he;
         he=he*2;
         tmp0=(e*w-q)./p;
         fi=find(tmp0>0);
         tmp=sum(sqrt(tmp0(fi)).*hs(fi));
         kn=floor(tmp/pi-1);
        end
        ind=fi(end)+1;
        tmp=0;
        while tmp<18 && ind<length(tmp0)+1
         tmp=tmp+sqrt(-tmp0(ind))*hs(ind);
         ind=ind+1;
        end
    end
    x=xs(ind);
end


end

function [x] = get_x_min(problem,pmax,indices)
%left-hand truncation point
qfun=problem.qfun; wfun=problem.wfun; pfun=problem.pfun;
if isinf(problem.b)
      hs=0.005*1.01.^(1:6000);
      t=cumsum(hs);
      x1= [-t(end:-1:1) t];
      xs= (x1(2:end)+x1(1:end-1))/2;
      hs= x1(2:end)-x1(1:end-1);
else
      b=problem.b;  x1=[];
      if  b > 0
        he=b/1000;  
        x1= b:-he:0;
        b=0;
      end
      hs=0.005*1.01.^(1:6000);
      x1= [x1 cumsum([b -hs])];
      xs= (x1(end-1:-1:1)+x1(end:-1:2))/2;
      hs= x1(end-1:-1:1)-x1(end:-1:2);
end
q=qfun(xs); w=wfun(xs);  p=pfun(xs);
if indices   
    emin = min(q)/max(w)-1;
    mw=mean(w);
    if mw< eps
      e2 = mean(q)/median(w);  
    else
      e2 = mean(q)/mean(w);
    end
    e=emin;
    he=(e2-emin)/10;    
    while true
      tmp0=(e*w-q)./p;
      fi=find(tmp0>0);
      tmp=sum(sqrt(tmp0(fi)).*hs(fi));
      k=tmp/pi-1;
      if k<pmax
          emin=e;
          kmin=k;
          e=e+he;
      else
          emax=e;
          kmax=k;
          break;
      end
    end
    it=0;
    while true
      it=it+1;  
      tmp0=(e*w-q)./p;
      fi=find(tmp0>0);
      tmp=sum(sqrt(tmp0(fi)).*hs(fi));
      k=tmp/pi-1;
      if k<pmax-0.2
          emin=e;
          kmin=k;
      elseif k>pmax+2
          emax=e;
          kmax=k;
      else
          break
      end
      if mod(it,2)==0
        e=(emax+emin)/2;
      else
         e=(emax-emin) * (pmax-kmin) / (kmax-kmin) + emin;
         if e==emin
             e=emin+(emax-emin)/10;
         end
      end
      if it>10000
          error(['The eigenvalue with index '  num2str(pmax) ' can not be computed'])
      end
    end
%    turning_point=xs(fi(1)-1)
    ind=fi(1)-1;
    tmp=0;
    while tmp<18
       tmp=tmp+sqrt(-tmp0(ind))*hs(ind);
       ind=ind-1;
    end
    x=xs(ind);
else
    e=pmax;
    tmp0=(e*w-q)./p;
    fi=find(tmp0>0);
    ind=fi(1)-1;
    tmp=0;
    while tmp<18
       tmp=tmp+sqrt(-tmp0(ind))*hs(ind);
       ind=ind-1;
    end
    x=xs(ind);
end

end